# Hellscape Navigator

(singleplayer GZDoom mod)

Hellscape Navigator is a collection of tools designed to help navigation in
complex maps.

<a href="https://github.com/mmaulwurff/hellscape-navigator/releases" alt="Downloads">
  <img src="https://img.shields.io/github/downloads/mmaulwurff/hellscape-navigator/total" />
</a>

## Features

* Automap Markers
  * Footsteps: display visited places
  * Fade with time
  * Configurable looks: footsteps/arrow/point
  * Configurable lifetime and generation period
  * Use markers (via binded key)

* Signs
  * A Sign can be placed to leave a note on level (use Sign to read the note)
  * Three kinds: wooden/metal/transparent to fit level theme
  * Can be configured to be indestructible or not
  * Present on automap
  * Can be displayed on compass
  * Can be thrown (useful for testing teleports)

* Compass
  * Shows view direction
  * Can show pointers for switches (only if close)
  * Different styles, sizes, and width

* Area Names
  * Entrance/Exit/Outdoors/Secrets
  * A Sign can be configured to create custom area with name

* Helper items
  * Reveal map on level start
  * Reveal map when it is mostly explored
  * Give scanner on map revealing
  * Entryway Translocator (teleport to start)
  * SpaceTunnelingDevice (temporary noclip)

* UI/Display
  * Colored messages for keys and doors (Doom, Heretic, Hexen)
  * Grid coordinates
  * Exploration status
  * Display locked door status
  * Custom automap arrow
  * Displaying map name on level start
  * Moving speed
  * Breadcrumbs

* Miscellaneous
  * Auto use (doors, switches)
  * Backtrack key

## Thanks

* all GZDoom developers for GZDoom.
* Doom community for thousands of maps to play.
* ramon.dexter for testing and feature suggestions.
* ShockwaveS08 for bug reports and feature suggestions.
* Clifford21 for feature suggestions.
* Cyanide for feature suggestions.
* Enjay for testing, bug reports, and feature suggestions.
* mrtaterz for feature suggestions.
* ImJezze for new features (see below) and code cleanup.
* Accensus for new sign design and sprites and bug reports.

## Credits

* Entryway Translocator and Space Tunneling Device graphics: [Freedoom](https://freedoom.github.io/)
  Copyright © 2001-2017 Contributors to the Freedoom project. All rights reserved.
* "Doom" style for compass grahpics: id Software.
* ImJezze: 'Pixel' style for compass, 'Doom' compass pointer style, and wide mode.
* Accensus for all the frankenspriting.
* cc4-tex for the textures used as base for signs.
* Russian Overkill for the hover sign's thrusters. Taken from the shield sprites.

## Links and Contacts

[Source](https://github.com/mmaulwurff/hellscape-navigator)

[Screenshots](https://imgur.com/a/pZ10Hss)

[Forum Post](https://forum.zdoom.org/viewtopic.php?f=43&t=61643#p1068272)

Author: Alexander "m8f" Kromm (mmaulwurff@gmail.com)

License: GPLv3 (see copying.txt)
